#!ruby -Ke
#
#  TOPPERS/A-WDG
#      Automotive Watchdog Driver
#
#  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
#                             Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
#  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
#  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
#  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
#  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2014-2015 by Witz Corporation
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: get_spec_id.rb 1340 2015-04-22 01:20:50Z fsi-kaitori $
#

#=====================================================================
# ƥȥե(wdg_spec.txt)顤WDG˴ؤͥȴФơ
# IDեؽϤ
# ƥȥեϡͽWordѴǽѤƺ
#=====================================================================

# 񤭽Фե
sWriteFileId = File.dirname(__FILE__) + "/wdg_spec_id.txt"

# pdfɤ߽Фƥȥǡ
sTextFile = "wdg_spec.txt"
sTextSpe = "../doc/wdg_spec.txt"
sTextDes = "../doc/wdg_design.txt"

# ƥȥեɤ߹
sText = File.read(sTextFile) + File.read(sTextSpe) + File.read(sTextDes)

# Ԥ(ǲԤ륱б)
sText.gsub!("\r\n", "")
sText.gsub!("\r", "")
sText.gsub!("\n", "")

# оݥ򸡺
aData1 = sText.scan(/\[WDG[0-9][0-9][0-9]\]/)
aData2 = sText.scan(/WDG[0-9][0-9][0-9]_Conf/)
aData3 = sText.scan(/WDGa[0-9][0-9][0-9]/)
aData4 = sText.scan(/NWDG[0-9][0-9][0-9]/)
aData5 = sText.scan(/DWDG[0-9][0-9][0-9]/)

# 줿ͥ
aDelTag = []

# פʸ
aTmp = []
aData1.each{|sTag|
  if (sTag.include?(""))
    aDelTag.push(sTag.gsub(/\[(WDG[0-9][0-9][0-9])\]/, "\\1"))
  else
    aTmp.push(sTag.gsub(/\[(WDG[0-9][0-9][0-9])\]/, "\\1"))
  end
}
aData1 = aTmp

# ʣID
aData1.uniq!
aData2.uniq!
aData3.uniq!
aData4.uniq!
aData5.uniq!

# ο¬
nData1 = aData1.size()
nData2 = aData2.size()
nData3 = aData3.size()
nData4 = aData4.size()
nData5 = aData5.size()

# 
aData = aData1 + aData2 + aData3 + aData4 + aData5

# IDǥ
aData.sort!

# 1Ĥʸˤ
sOutString = aData.join("\n")

# եؽϤ
File.open(sWriteFileId, "w") {|io|
  io.puts(sOutString)
}

# IDηɽ
puts("=" * 20)
printf("WDG***      : %3d\n", nData1)
printf("WDG***_Conf : %3d\n", nData2)
printf("WDGa***     : %3d\n", nData3)
printf("NWDG***     : %3d\n", nData4)
printf("DWDG***     : %3d\n", nData5)
puts("-" * 20)
printf("Total       : %3d\n", (nData1 + nData2 + nData3 + nData4 + nData5))
puts("=" * 20)
printf("Delete tags : %3d\n", aDelTag.size())
if (aDelTag != nil)
  aDelTag.sort!
  puts("-" * 20)
  aDelTag.each{|sDelTag|
    puts(sDelTag)
  }
end
puts("=" * 20)
