@echo off
rem #
rem #  TOPPERS/A-WDG
rem #      Automotive Watchdog Driver
rem #
rem #  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
rem #                             Graduate School of Information Science, Nagoya Univ., JAPAN
rem #  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
rem #  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
rem #  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
rem #  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
rem #  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
rem #  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
rem #  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
rem #  Copyright (C) 2014-2015 by Witz Corporation
rem #
rem #  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
rem #  Ai{\tgEFAς̂܂ށDȉjgpEE
rem #  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
rem #  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
rem #      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
rem #      XR[hɊ܂܂Ă邱ƁD
rem #  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
rem #      pł`ōĔzzꍇɂ́CĔzzɔhLgip
rem #      ҃}jAȂǁjɁCL̒쌠\C̗pщL
rem #      ̖ۏ؋Kfڂ邱ƁD
rem #  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
rem #      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
rem #      ƁD
rem #    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
rem #        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
rem #    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
rem #        񍐂邱ƁD
rem #  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
rem #      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
rem #      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
rem #      RɊÂCL쌠҂TOPPERSvWFNg
rem #      Ɛӂ邱ƁD
rem #
rem #  {\tgEFÁCAUTOSARiAUTomotive Open System ARchitecturejd
rem #  lɊÂĂDL̋́CAUTOSAR̒mIŶ
rem #  ͂ȂDAUTOSAŔCAUTOSARdlɊÂ\tgEFApړIŗ
rem #  p҂ɑ΂āCAUTOSARp[gi[ɂȂ邱Ƃ߂ĂD
rem #
rem #  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
rem #  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
rem #  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
rem #  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
rem #  ̐ӔC𕉂ȂD
rem #
rem #  $Id: wdgcfg.bat 1340 2015-04-22 01:20:50Z fsi-kaitori $
rem #

set RUBY_HOME=c:\cygwin
set PATH=%RUBY_HOME%\bin;%PATH%

set OS_DIR=../../../../../../atk2-sc1/
set CFG_DIR=%OS_DIR%/cfg/cfg
set ABREX_DIR=%OS_DIR%/utils/abrex
set TARGET_DIR=%OS_DIR%/target/fl850f1l_gcc
set WDG_PATH=../../../..
set WDG_TARGET_PATH=../..

ruby %ABREX_DIR%/abrex.rb wdg.yaml

echo execute cfg wdg.arxml
start /b %CFG_DIR%/cfg.exe --omit-symbol --pass 2 --kernel atk2 --ini-file %WDG_PATH%/wdg.ini --api-table %WDG_PATH%/wdg.csv -I %WDG_PATH% -T %WDG_TARGET_PATH%/Wdg_Target.tf wdg.arxml %TARGET_DIR%/target_hw_counter.arxml

ruby %ABREX_DIR%/abrex.rb os.yaml

patch -u %OS_DIR%/arch/v850_ccrh/prc_support.asm < %WDG_TARGET_PATH%/wdg_nmi.patch

pause
exit
